<?php

# Copyright (C) 2004 Bull Media
# Written by James Mclean <james@bullmedia.com.au>

# Quoting Module: Module to allow a quote to dynamically be created and
# then once approved, added to the projects module with individual items 
# in the quote assigned to various workers.

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


class Quoting {

    # Items in the current quote.
    var $quoteitems     = array();
    var $externalItems  = array();
    var $selected       = '';

    function cleanText($text) {

        $text = strip_tags($text);
        $text = stripslashes($text);
        $text = ereg_replace("\\\\","",$text);

        return $text;

    }

    function buildTypes($selected = '',$id = '-1') {

        require_once(INCLUDEPATH . "mSelectBox.class.php");
        
        if($id=='-1')
            $name = "itemType";
        else
            $name = "itemSelect[]";
            
        $ser = new mSelectBox("$name");
        $ser->addOption("0","Internal Service");
        $ser->addOption("1","External Service");       
 
        return $ser->draw($selected);
    }

    function showTasks() {
        global $smarty, $conn;

        # Display all the tasks, in a nice editable format.

        # Tell smarty to display all.
        $smarty->assign('type','view');
    
        $sql = "SELECT * FROM mgw_yb_quoting_service";

        $rs = $conn->Execute($sql);
        
        $i = 0;
        while($row = $rs->FetchRow()) {
            $row[types] = $this->buildTypes($row[quoteType],$row[quoteID]);
            $res[$i] = $row;
            $i++;
        } 
        $smarty->assign('tasks',$res);
    }

    function addTask() {
        global $smarty, $conn;

        if($_REQUEST['type'] == 'save') {

            for($i=0;$i<sizeof($_REQUEST[task]);$i++) {
                $task = $_REQUEST[task][$i];
                $sele = $_REQUEST[itemSelect][$i];
                $id   = $_REQUEST[id][$i];
                $rate = $_REQUEST[rate][$i];

                $usql = "UPDATE mgw_yb_quoting_service 
                         SET quoteName='$task', quoteType='$sele', quoteRate='$rate' 
                         WHERE quoteID='$id'
                        ";

                if(!$conn->Execute($usql))
                    exit(showSQLerror($usql, $conn->ErrorMsg(), __LINE__, __FILE__));              

                $smarty->assign('updated','1');
            }
        }

        if($_REQUEST['addTask']) {

            $ssql = "SELECT COUNT(*) AS count FROM mgw_yb_quoting_service";
            $scount = $conn->Execute($ssql); 
            if(!$scount)
                exit(showSQLerror($usql, $conn->ErrorMsg(), __LINE__, __FILE__));

            $id = $scount->fields[count];
            $id++;

            $sql = "INSERT INTO mgw_yb_quoting_service (quoteID,quoteName,quoteType,quoteRate) VALUES ('$id','$_REQUEST[newTask]','$_REQUEST[itemType]','$_REQUEST[newRate]')";
    
            if(!$conn->Execute($sql)) {
                exit(showSQLerror($usql, $conn->ErrorMsg(), __LINE__, __FILE__));
            }
        }

        if($_REQUEST['deleteTask']) {
            for($i=0;$i<sizeof($_REQUEST[deleteTask]);$i++) {
                $id = $_REQUEST[deleteTask][$i];

                $sql = "DELETE FROM mgw_yb_quoting_service WHERE quoteID='$id'";

                $conn->Execute($sql);
 
            }
        }

        $smarty->assign('newType',$this->buildTypes());

        # Show the tasks.
        $this->showTasks();

        $smarty->display("quoting_addtask.tpl");
    }

    function overview() {
        global $conn, $appconf, $smarty;

        $icons = getIconStrings();
        $space = $icons["space"];

        $smarty->assign("prevsym", $icons["prev"]);
        $smarty->assign("nextsym", $icons["next"]);

        if($_REQUEST[type] == 'all' OR !$_REQUEST[type]) {
            $sql = "SELECT * 
                    FROM mgw_yb_quoting
                    WHERE archived='0'
                    AND visible='1' 
                    ORDER BY dateadded DESC
                   ";

            $smarty->assign("thetitle", "Quotes - Overview");

        } elseif($_REQUEST[type] == 'arch') {
            $sql = "SELECT * 
                    FROM mgw_yb_quoting 
                    WHERE archived='1' 
                    ORDER BY dateadded DESC
                   ";

            $smarty->assign("thetitle", "Quotes - Archive");

        }

        $urls = array();

        if(!$res = $conn->Execute($sql)) 
            exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));

        while ($row = $res->FetchRow()){

            $qid = $row[id];

            #$smarty->append("td1", $row[id]);
            $smarty->append("td1", $row[custid]);

            $companyid = $row["companyid"];
            $sql2 = "select name1 from mgw_companies where id=\"$companyid\"";
            if(!$res2 = $conn->Execute($sql2)) 
                exit(showSQLerror($sql2, $conn->ErrorMsg(), __LINE__, __FILE__));
            $smarty->append("td2", $res2->FetchRow());
            $whichuser = $row["lu_user"];

            $sql4 = "select concat(lastname, ', ', firstname) as name from mgw_users where id=\"$whichuser\"";

            if(!$res4 = $conn->Execute($sql4)) 
                exit(showSQLerror($sql4, $conn->ErrorMsg(), __LINE__, __FILE__));
            $smarty->append("td4", $res4->FetchRow());
            $row["dateadded"] = $conn->UnixTimestamp($row["dateadded"]);
            $row["lastrevised"] = $conn->unixTimestamp($row["lastrevised"]);
            $smarty->append("td",$row);
            $myid = $row['id'];
            $detlink = "<a href=\"".$_SERVER['PHP_SELF']."?mod=quoting&amp;action=details&amp;id=$myid&amp;".SID."\" CLASS=\"edit\">".$icons["details"]."</a>";
            $editlink = "<a href=\"".$_SERVER['PHP_SELF']."?mod=quoting&amp;obj=item&amp;action=quote&mode=edit&amp;id=$myid&amp;".SID."\" CLASS=\"edit\">".$icons["edit"]."</a>";
            $dellink = "<a href=\"".$_SERVER['PHP_SELF']."?mod=quoting&amp;obj=item&amp;action=archive&type=arch&amp;id=$myid&amp;".SID."\" CLASS=\"delete\">".$icons["delete"]."</a>";
            $space = $icons["space"];
            $urls[] = "<nobr>" . $detlink . $space . $editlink  . $space . $dellink . "</nobr>";
            $smarty->assign('urls', $urls);
        };
        $smarty->assign("action", $_REQUEST["action"]);
        $smarty->display('quoting_overview.tpl');
    }

    function details() {
        global $conn, $appconf, $smarty;
        $id = (int) $_REQUEST["id"];
        $sql = "SELECT * from mgw_yb_quoting WHERE id=$id";
        if(!$res = $conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
        $row = $res->FetchRow();
        $companyid = $row["companyid"];
        $sql2 = "SELECT name1 from mgw_companies WHERE id=$companyid";
        if(!$res2 = $conn->Execute($sql2)) exit(showSQLerror($sql2, $conn->ErrorMsg(), __LINE__, __FILE__));
        $row2 = $res2->FetchRow();
        $whichuser = $row["lu_user"];
        $sql4 = "SELECT concat(lastname, ', ', firstname) AS name from mgw_users WHERE id=$whichuser";
        if(!$res4 = $conn->Execute($sql4)) exit(showSQLerror($sql4, $conn->ErrorMsg(), __LINE__, __FILE__));
        $row4 = $res4->FetchRow();

        $smarty->assign("company", $row2["name1"]);
        $smarty->assign("whichuser", $row4["name"]);

        $icons = getIconStrings();
        $space = $icons["space"];
        $row["dateadded"] = $conn->UnixTimestamp($row["dateadded"]);
        $smarty->assign("id", $id);
        $smarty->assign("td", $row);
        $smarty->assign("action", $_REQUEST["action"]);
        $smarty->assign("contentheader", Lang::getLanguageString("detailview"));
        $smarty->assign("ty", $_GET["ty"]);
        $smarty->assign("suclass", "submit");
        $smarty->display('quoting_details.tpl');
    }

    function drawHours($hours,$i='-1',$type='-1') {
        # Ugly hack to get around a Smarty 'feature'
        return  "name=quoteArrayHours[$i] value=$hours"; 
    }


    function drawAspects($selected,$i='-1',$type='-1') {

        global $smarty, $conn;

        require_once(INCLUDEPATH . "mSelectBox.class.php");

        if($i=='-1') {
            $name = "quoteName";
        } else {
            $name = "quoteArrayItem[$i]";
        }

        $ser = new mSelectBox($name);
        $ser->setContentType("sql");
        $ser->setSQLValue("quoteID");
        $ser->setSQLContent("quoteName");
        $ser->addOption(" "," ", "pre");
        $ser->addContent("SELECT quoteID, quoteName FROM mgw_yb_quoting_service WHERE quoteType='0'");
        $ser->addOption("","-----");
        $ser->addContent("SELECT quoteID, quoteName FROM mgw_yb_quoting_service WHERE quoteType='1'");

        return $ser->draw($selected);

    }

    function getItemType($id) {

        global $conn;

        $sql = "SELECT quoteType 
                FROM mgw_yb_quoting_service 
                WHERE quoteID='$id'
               "; 

        $rs = $conn->Execute($sql);

        return $rs->fields[quoteType];

    }

    function getItemRate($id) {

        global $conn;

        $sql = "SELECT quoteRate FROM mgw_yb_quoting_service WHERE quoteID='$id'";
    
        $rs = $conn->Execute($sql);
        $row = $rs->FetchRow();

        return $row[quoteRate];
    }

    function assignAspects() {

        global $smarty;

        if(!$finalq)
            $finalq = array();

        for($i=0;$i<sizeof($_SESSION[quote]);$i++) {

            $cost = $this->getItemRate($_SESSION[quote][$i][aspect]) * $_SESSION[quote][$i][hours];

            $type = $this->getItemType($_SESSION[quote][$i][aspect]);

            if($type == '0') {
                $ttime = $ttime + $_SESSION[quote][$i][hours];
                $tcost = $tcost + $cost;
            } elseif($type == '1') {
                # Ok, external service here, this is added to the total
                # cost! Oh kludge.
                $tcost = $tcost + $_SESSION[quote][$i][hours];
                $ecost = $_SESSION[quote][$i][hours];  
            }

            # Oh kludgy arrays.
            $quotes = array("$i" => array("dd" => $this->drawAspects($_SESSION[quote][$i][aspect],$i),
                                          "tf" => $this->drawHours($_SESSION[quote][$i][hours],$i),
                                          "id" => $i,
                                          "ty" => $type, 
                                          "de" => $_SESSION[quote][$i][desc],
                                          "ra" => ($type == '1') ? $ecost : $cost,
                                          "us" => $this->assignUserlist("userlist[$i]",$_SESSION[quote][$i][user])
                            ));
            $finalq = $finalq + $quotes;
        }
        
        $gst = ($tcost * 11) / 100;

        $smarty->assign('gstamt',number_format($gst,2));
        $smarty->assign('cost',number_format(($tcost + $gst),2));
        $smarty->assign('time',$ttime);

        return $finalq;

    }


    function createProject($id) {

        global $conn, $smarty;

        $sql = "SELECT * 
                FROM mgw_yb_quoting
                WHERE id='$id'
               "; 

        $rs = $conn->Execute($sql);
        $tstamp = $conn->Execute("SELECT DATE_FORMAT(targetdate, '%Y-%m-%d') AS targetdate FROM mgw_yb_quoting WHERE id='$id'");

        if(!$rs)
            exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));

        $idnum          = $conn->GenID('mgw__seq_projects'); 
        $projectname    = $rs->fields[projectname];
        $notes          = $rs->fields[notes];
        $companyid      = $rs->fields[companyid];
        $projleader     = $rs->fields[lu_user];
        $keyaccount     = $rs->fields[lu_user];
        $startdate      = date("Y-m-d");
        # here be DRAGONS!
        $targetdate     = $tstamp->fields[targetdate]; #***!!! WARNING !!!*** 
        $owner          = $rs->fields[lu_user];
        $lu_user        = $rs->fields[lu_user];


        $createProject = "INSERT INTO mgw_projects ( project_id,  title,  description,  companyid,  projleaderid,  keyaccountid,  startdate,  targetdate, owner, lu_user,  lu_date) VALUES ('$idnum','$projectname','$notes','$companyid','$projleader','$keyaccount','$startdate','$targetdate','$owner','$lu_user',NOW())";

        if(!$conn->Execute($createProject))
            exit(showSQLerror($createProject, $conn->ErrorMsg(), __LINE__, __FILE__));

        # add aspects to project.

        $asql = "SELECT t1.*, t2.quoteType 
                 FROM mgw_yb_quoting_lookup AS t1, mgw_yb_quoting_service AS t2 
                 WHERE t1.quoteID='$id'
                 AND t2.quoteType='0'
                 AND t1.aspectID=t2.quoteID
                ";

        $ars = $conn->Execute($asql);
        if(!$ars)
            exit(showSQLerror($asql, $conn->ErrorMsg(), __LINE__, __FILE__));

        if($ars) {
            while($row = $ars->FetchRow()) {

                $asql2  = "SELECT quoteName 
                           FROM mgw_yb_quoting_service 
                           WHERE quoteID='$row[aspectID]'
                          ";
    

                $ars2   = $conn->Execute($asql2);
                if(!$ars2)
                    exit(showSQLerror($asql2, $conn->ErrorMsg(), __LINE__, __FILE__));

                $taskid = $conn->GenID('mgw__seq_projects_tasks'); 
                $idnum  = $idnum;
                $title  = $ars2->fields[quoteName];
                $hours  = $row[aspectHours];

                if($row[aspectUser] == '' || $row[aspectUser] == '0') {
                    $user = $lu_user;
                } elseif($row[aspectUser] != '') { 
                    $user = $row[aspectUser];
                } 

                if($user == '0') {
                    # Fall back. If we save '0', it breaks projects.
                    # Set to admin user.
                    $user = '1';

                }

                $isql   = "INSERT INTO mgw_projects_tasks (task_id, project_id, title, description, status, hours, startdate, targetdate, assignee) VALUES ('$taskid','$idnum','$title','$row[aspectDesc]','1','$hours',NOW(),'$targetdate','$user')";

                if(!$conn->Execute($isql))
                    exit(showSQLerror($isql, $conn->ErrorMsg(), __LINE__, __FILE__));

            }
        }

        $usql = "UPDATE mgw_yb_quoting 
                 SET approvedProjectID='$idnum', archived='1'
                 WHERE id='$id'
                "; 

        if(!$conn->Execute($usql))
            exit(showSQLerror($isql, $conn->ErrorMsg(), __LINE__, __FILE__));

        # Tell smarty right now its created.
        $smarty->assign('approvedProjectID',$idnum);

    }

    function loadSession($quoteID,$quoteHours) {

        $_SESSION[quote][] = array("aspect" => "$quoteID",  
                                   "hours"  => "$quoteHours"
                                  );
    }

    function assignItems($insarr) {

        global $smarty, $conn;

        $arr = $insarr;

        for($i=0;$i<sizeof($arr);$i++) {
            # Splits the array for services between internal
            # and External

            if($arr[$i][ty] == '0')
                $items1[] = $arr[$i];
            elseif($arr[$i][ty] == '1')
                $items2[] = $arr[$i];

        }

        $smarty->assign('items',$items1);
        $smarty->assign('extitems',$items2);

    }



    /*
     * Function tracks and works with a live quote in the system
     * Its a bit more messy that I would like.
     *
     * Originally written by Ryan Verner <ryan@bullmedia.com.au>
     * Butchered to death by James Mclean <james@bullmedia.com.au>
     *
     */

    function quote() {

        global $conn, $appconf, $smarty;

        require_once(INCLUDEPATH . "mSelectBox.class.php");

        # first things first. Send the ID. Know what we are talking about.
        $smarty->assign('id',$_REQUEST[id]);

        if($_REQUEST[mode] == 'new') {
            $smarty->assign("mode", "new");

            # generate a quote number here.
            $id = $conn->GenID('mgw_yb__seq_quoting');
            $smarty->assign("quotenumber",$id);
            $smarty->assign("id",$id);

            $sql = "INSERT INTO mgw_yb_quoting (id,dateadded,visible,lastrevised) 
                    VALUES ($id,NOW(),0,NOW())";

            if(!$conn->Execute($sql)) 
                exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
           
            # Kill the nasty session that my have pre-existed.
            $_SESSION[quote] = array();

            # make it think its loaded, dont wnat to load from the DB
            # each time.
            $smarty->assign('loaded','1');
            $smarty->assign('approved','0');

        } elseif($_REQUEST[mode] == 'save') {

            # We process it all first. If its a save, then tis all good.

            # Reassign all the the varibles sent to us back into
            # the Smarty engine, for re-display.


            foreach ($_REQUEST as $key => $value) {
                $smarty->assign($key,$this->cleanText($value));
            }

            $td = "$_REQUEST[TargetYear]-$_REQUEST[TargetMonth]-$_REQUEST[TargetDay]";
            $smarty->assign('td',$td);

            if($_REQUEST[op]) {
                # We need to save the info into the database here.
                # If its asked for.

                # If the 'Save'/'Update' button is selected, then this
                # 'op' varible is present.

                # This assumes the user has saved all his information
                # before clicking the save button. Could be a bad thing to
                # have. IMHO, its ok.
      
                if(strlen($_REQUEST[TargetDay])<'2')
                    $_REQUEST[TargetDay] = "0" . $_REQUEST[TargetDay];
           
                if(strlen($_REQUEST[TargetMonth])<'2')
                    $_REQUEST[TargetMonth] = "0" . $_REQUEST[TargetMonth];

                if(strlen($_REQUEST[AddedMonth])<'2')
                    $_REQUEST[AddedMonth] = "0" . $_REQUEST[AddedMonth];
        
                if(strlen($_REQUEST[AddedDay])<'2')
                    $_REQUEST[AddedDay] = "0" . $_REQUEST[AddedDay];

                # We need to insert the current quote as a new quote, and 
                # update the old quote, so this new quote is the parent.

                if($_REQUEST[revised] == '1') {
                    #print"Revised quote. ";
                    #print"Insert new quote here. Update old quote with this quotes ID, as Parent.";
                }

                $ts = $_REQUEST[TargetYear].'-'.$_REQUEST[TargetMonth].'-'.$_REQUEST[TargetDay].' '.$_REQUEST[TargetHour].':'.$_REQUEST[TargetMinute].'00';
                $targetdate=$conn->DBTimeStamp($ts);
                // replaced: targetdate  = '$_REQUEST[TargetYear]$_REQUEST[TargetMonth]$_REQUEST[TargetDay]$_REQUEST[TargetHour]$_REQUEST[TargetMinute]00', (k-fish)
                $sql = "UPDATE mgw_yb_quoting
                        SET companyid   = '$_REQUEST[companyid]',
                            custid      = '$_REQUEST[custqnum]',
                            lu_user     = '$_REQUEST[owneruserlist]',
                            notes       = '$_REQUEST[quotedesc]',
                            projectname = '$_REQUEST[proname]',
                            targetdate  = ".$targetdate.",
                            visible     = '1',
                            lastrevised = NOW() 
                        WHERE id='$_REQUEST[id]'
                       ";
        
                if(!$conn->Execute($sql))
                    exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
                
                # Ok, were all saved.

                # Now work with the $_SESSION[quote] array to save that, too.

                # DELETE all from the lookup! kludge the hack! 
                $dsql = "DELETE FROM mgw_yb_quoting_lookup WHERE quoteID='$_REQUEST[id]'";
                if(!$conn->Execute($dsql))
                     exit(showSQLerror($dsql, $conn->ErrorMsg(), __LINE__, __FILE__));

                for($i=0;$i<sizeof($_SESSION[quote]);$i++) {
                    $aid = $_SESSION[quote][$i][aspect];
                    $ahr = $_SESSION[quote][$i][hours];
                    $des = $_SESSION[quote][$i][desc];
                    $usr = $_SESSION[quote][$i][user];

                    $sql = "INSERT INTO mgw_yb_quoting_lookup (quoteID, aspectID, aspectHours, aspectDesc,aspectUser) 
                            VALUES ('$_REQUEST[id]','$aid','$ahr','$des','$usr')
                           ";

                    if(!$conn->Execute($sql))
                        exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));

                }

                # Add something here that tells the GUI it all updated ok.
                $smarty->assign('saved','1');


                if($_REQUEST[approval] == '1') {
                    # Approved checkbox is selected, save to 'Projects' module.

                    $usql = "UPDATE mgw_yb_quoting 
                             SET approved='1' 
                             WHERE id='$_REQUEST[id]'
                            ";
                   
                    if(!$conn->Execute($usql)) 
                        exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
                    # Calls the function...
                    $this->createProject($_REQUEST[id]);
                }

 
            } elseif($_REQUEST[additem]) {
                # If the 'Ok, Add Item' button is selected, this
                # variable is present

                # ok we know they are adding just an item to 
                # the current quote.

                # Save it in our own element of the $_SESSION array. 
                # I love sessions.

                # This only makes them persist. Smarty doesnt know they 
                # exist yet!

                # first, go through the array to see if were already listed
                for($i=0;$i<sizeof($_SESSION[quote]);$i++) {
                    foreach($_SESSION[quote][$i] as $tkey => $tval) {
                        if($tkey == $_REQUEST[quoteName]) {
                            # Were listed, increment. 
                            $tval = $tval + $_REQUEST[quoteHours];
                    
                            # Reassign back to the session.
                            $_SESSION[quote][$i][$tkey] = $tval;
                        
                            $added = 1;
                        }
                    }
                } 

                # \o\ \o/ /o/ the crowd cheers!

                # add to the main array in the $_SESSION
                if(!$added) {
                    if($_REQUEST[quoteName]>'0' && $_REQUEST[quoteHours]>'0') {
                        $this->loadSession($_REQUEST[quoteName],$_REQUEST[quoteHours]);
                    }
                }

                # This sets the date/time for the thing thats does stuff..
                # :P its assigns the passed date/time back to the page :)
                $td = "$_REQUEST[TargetYear]-$_REQUEST[TargetMonth]-$_REQUEST[TargetDay]";

                $smarty->assign("td",$td);


            } elseif($_REQUEST[saveQuotedItems]) {
                # This is the 'Save' button for the items in the quote.
                # Update the array of items that are in the current quote.
       
                # Arrays were using, quoteArrayItem && quoteArrayHours

 
                for($i=0;$i<sizeof($_SESSION[quote]);$i++) {

                    $_SESSION[quote][$i][aspect] = $_REQUEST[quoteArrayItem][$i]; 
                    $_SESSION[quote][$i][hours]  = $_REQUEST[quoteArrayHours][$i];
                    $_SESSION[quote][$i][type]   = $this->getItemType($_REQUEST[quoteArrayItem][$i]);
                    $_SESSION[quote][$i][desc]   = $_REQUEST[description][$i];
                    $_SESSION[quote][$i][user]   = $_REQUEST[userlist][$i];
 
                }

                if($_REQUEST[deleteQuoted]) {
                    foreach($_REQUEST[deleteQuoted] as $key => $val) {
                        unset($_SESSION[quote][$key]);
                    }
                }

                # Need to SORT!! unset()ing the var above causes problems in
                # the yb gui, as a result of a previous hack, as a result of 
                # a Smarty 'inconsistancy'.
                sort($_SESSION[quote]);
            }

            # Tell smarty the array exists, it will know what to do ;D      
            # (displays in the page, the items in the quote).
            if(isset($_SESSION[quote])) {
                $this->assignItems($this->assignAspects());
            }
        } 


        # <clippy>
        # Looks like you're loading a Quote. What would you like to do?
        # 1) Retrieve from a Database via ADOdb?
        # Yes.

        if($_REQUEST[id] && !$_REQUEST[loaded]) {
            $sql = "SELECT id,
                           custid, 
                           companyid, 
                           lu_user, 
                           stat, 
                           notes, 
                           dateadded, 
                           projectname, 
                           targetdate,
                           approved,
                           approvedProjectID,
                           archived, 
                           UNIX_TIMESTAMP(targetdate) AS tda, 
                           UNIX_TIMESTAMP(dateadded) AS dadd
                    FROM mgw_yb_quoting 
                    WHERE id='$_REQUEST[id]'
                   ";

            $rs = $conn->Execute($sql);

            if(!$rs) 
                exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));

            # Kill the nasty session that my have pre-existed.
            $_SESSION[quote] = array();

            $smarty->assign('custqnum',$rs->fields[custid]);
            $smarty->assign('quotenumber',$rs->fields[id]);
            $smarty->assign('proname',$rs->fields[projectname]);
            $smarty->assign('quotedesc',$rs->fields[notes]);
            $smarty->assign('proname',$rs->fields[projectname]);
            $smarty->assign('approved',$rs->fields[approved]);
            $smarty->assign('approvedProjectID',$rs->fields[approvedProjectID]);


            # These are assigned to Smarty below. Just create a
            # variable, and the rest of the script works it out.
            $companyid      = $rs->fields[companyid];
            $lu             = $rs->fields[lu_user];

            # parse the date/time/min/sec/usec/anything...
            
            # need to load the aspects from the database too..
            $asql = "SELECT * 
                     FROM mgw_yb_quoting_lookup 
                     WHERE quoteID='$_REQUEST[id]'
                    ";

            $ars = $conn->Execute($asql);
            if(!$ars) {
                exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
            } else {
                $i=0;
                while($arr = $ars->FetchRow()) {

                    $_SESSION[quote][$i][aspect] = $arr[aspectID];
                    $_SESSION[quote][$i][hours]  = $arr[aspectHours];
                    $_SESSION[quote][$i][type]   = $this->getItemType($arr[aspectID]);
                    $_SESSION[quote][$i][desc]   = $arr[aspectDesc];
                    $_SESSION[quote][$i][user]   = $arr[aspectUser];
 
                    $i++;
                }
            }

            # Execute the function to assign them to smarty.
            #$smarty->assign('items',$this->assignAspects());

            $this->assignItems($this->assignAspects());
            

            # tell smarty this is already loaded, dont load again
            $smarty->assign('loaded',1);

            $td  = date('Y-m-d',$rs->fields[tda]);
            $sts = date('Y-m-d',$rs->fields[dadd]);

            $smarty->assign('td',$td);
            $smarty->assign('sts',$sts);
            
            # Its a REVISION!
            $revised = 1;   
 
        }

        # </clippy>

        if(!$approval)
            $smarty->assign('approved','0');

        $smarty->assign("pubcheckedyes"," checked");
        $smarty->assign("suclass","submit");
        $smarty->assign("sselecttype3", "checked");
        $smarty->assign("eselecttype2", "checked");

        $smarty->assign("servicelist",$this->drawAspects('0'));

        if(!$companyid)
            $companyid = $_REQUEST[companyid];

        $sb4 = new mSelectBox("companyid");
        $sb4->setContentType("sql");
        $sb4->setSQLvalue("id");
        $sb4->setSQLcontent("name1");
        $sb4->addContent("SELECT * FROM mgw_companies ORDER BY name1");
        $sb4->addOption("0", "None", "pre");
        $smarty->assign("companysb", $sb4->draw($companyid));

        if(!$lu)
            $lu = $_REQUEST[owneruserlist];

        $smarty->assign('revised',$revised);
        $smarty->assign('owneruserlist',$this->assignUserlist('owneruserlist',$lu));

        $smarty->display('quoting_edit.tpl');
    }

    function assignUserlist($assignvar,$selected='0') {

        global $conn, $smarty;

        require_once(INCLUDEPATH . "mSelectBox.class.php");



        $ul = new mSelectBox("$assignvar");
        $ul->setContentType("sql");
        $ul->setSQLValue("id");
        $ul->setSQLContent("name");
        $connstr = $conn->Concat("lastname","', '","firstname");
        $ul->addContent("SELECT id, $connstr AS name FROM mgw_users ORDER BY lastname");
        #$smarty->assign($assignvar, $ul->draw($selected));
        return $ul->draw($selected);

    }

    function quoteUpdate(){
        global $conn;
        $id = (int) $_POST["id"];

        $companyid = $conn->quote($_POST['companyid']);
        $lu_user = $conn->quote($_POST['lu_user']);
        $stat = $conn->quote($_POST['stat']);
        $notes = $conn->quote($_POST['notes']);

        $sql="UPDATE mgw_yb_quoting SET companyid=$companyid, lu_user=$lu_user, stat=$stat, notes=$notes WHERE id='$id'";
        if(!$conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
    }

    function quoteCreate(){
        global $conn;
        $id = $conn->GenID('mgw_yb__seq_quoting');

        $companyid = $conn->quote($_POST['companyid']);
        $lu_user = $conn->quote($_POST['lu_user']);
        $stat = $conn->quote($_POST['stat']);
        $notes = $conn->quote($_POST['notes']);

        $sql="INSERT INTO mgw_yb_quoting (id, companyid, lu_user, stat, notes) values ($id, $companyid, $lu_user, $stat, $notes)";
        if(!$conn->Execute($sql)) exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));
    }

    function quoteDelete() {

        global $conn, $smarty, $appconf;

        $id = (int) $_GET["id"];
        $sql = "SELECT * FROM mgw_yb_quoting WHERE id='$id'";

        if(!$res = $conn->Execute($sql)) 
            exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));

        $row = $res->FetchRow();

        $companyid = $row["companyid"];

        $sql2 = "SELECT name1 from mgw_companies where id=\"$companyid\"";

        if(!$res2 = $conn->Execute($sql2)) 
            exit(showSQLerror($sql2, $conn->ErrorMsg(), __LINE__, __FILE__));

        $row2 = $res2->FetchRow();

        $companyname = $row2["name1"]; 
        $smarty->assign("itemid", $row["id"]);
        $smarty->assign("deletedetail1", $companyname);
        $smarty->assign("deletedetail2", $row["notes"]);
        $smarty->assign("suclass", "submit");
        $smarty->assign("menuid", "3");
        $smarty->assign("parms", str_replace("action=delete","",$_SERVER["QUERY_STRING"]));
        $smarty->assign("deleteitem", "Delete Item"); 
        $smarty->assign("deleteheader", "Delete Quote?");
        $smarty->display($appconf["gentemplates"] ."/delete_item.tpl");

        exit();

    }

    function quoteArchive() {

        global $conn, $smarty, $appconf;

        $id = (int) $_GET["id"];

        # Hangon. What if was already archived?i
        # That means we want to DELETE!

        $ssql = "SELECT archived FROM mgw_yb_quoting WHERE id='$id'"; 
        $r = $conn->Execute($ssql);
        $ro = $r->FetchRow();

        if($ro[archived])
            $this->quoteDelete();


        #$sql = "INSERT INTO mgw_yb_quoting_archive select * from mgw_yb_quoting WHERE id='$id'";

        # Hmm, dont see why a seperate table is needed for the archive..
        $sql = "UPDATE mgw_yb_quoting 
                SET archived='1' 
                WHERE id='$id'
               ";

        if(!$res = $conn->Execute($sql)) 
            exit(showSQLerror($sql, $conn->ErrorMsg(), __LINE__, __FILE__));



    }

}

?>
